/* -*-C++-*- */
/* Copyright (c) 1999 Regents of the University of California.
 * rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *       This product includes software developed by the Imaging and
 *       Distributed Collaboratories Group at Lawrence Berkeley
 *       National Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
*/

#ifndef funcs_h
#define funcs_h

#include<string>
/*
#include <sys/socket.h> //AF_INET
#include <pthread.h>

#ifdef sun
#include <sys/systeminfo.h>
#endif

#ifdef linux
#include <sys/utsname.h>
#endif

#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h> //inet_ntoa
#include <sysexits.h>
//#include <cerrno>
#include <unistd.h>     // for close() with CC compiler
#include <sys/time.h>


#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN  256
#endif
*/

using std::string;

extern "C"   int passwdS_cb_Wrap( char* buff, int num, int verify, void* datatoPassBack );
extern "C"   int passwdC_cb_Wrap( char* buff, int num, int verify, void* datatoPassBack );
extern "C"   int passwdBlank_cb_Wrap( char* buff, int num, int verify, void* datatoPassBack );

int           interface_Input( bool isIn );
void 	      setPasswdS( const string passwd );
void 	      setPasswdC( const string passwd );
int   	      passwdS_cb( char* buff, int num, int verify, void* datatoPassBack );
int   	      passwdC_cb( char* buff, int num, int verify, void* datatoPassBack );
int   	      passwdBlank_cb( char* buff, int num, int verify, void* datatoPassBack );

string 	      temp_passwdC( const string pw );
string 	      temp_passwdS( const string pw );

void	      setPasswds( bool isServer );
string        set_passwd( void );
string        set_passwd( const string );
string 	      set_passwd_stdin( void );

string 	      getpass( char* buf, const char* prompt );
int 	      getLocalHostName( string& name );
string 	      getLocalHostName( void );
int           getCanonicalName( string& buf );

string        int_to_string(    int number    );
string        double_to_string( double number );
string        float_to_string(  float  number );

string 	      getToken( const string line, const string delimiters, const int tokenNum );

#endif
