/* -*-C++-*- */
/*
 *  Copyright (c) 1999 Regents of the University of California.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgment:
 *       This product includes software developed by the Imaging and
 *       Distributed Collaboratories Group at Lawrence Berkeley
 *       National Laboratory.
 *  4. Neither the name of the University nor of the Laboratory may be used
 *     to endorse or promote products derived from this software without
 *     specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 *  $Id: tcpnet.h,v 1.4 2001/08/30 02:05:27 boverhof Exp $
 */


#ifndef SOCKETX_H
#define SOCKETX_H

/* -------------------------------------------------------------------
 * Parent class to hold socket information. Has wrappers around
 * the common listen, accept, connect, and close functions.
 * ------------------------------------------------------------------- */

#include "network.h"
#include <string>
using std::string;

class TCPNet: public Network {

  public:
    
    TCPNet( int fd=0, int timeout=1, short inPort=5554 );
    virtual ~TCPNet();

    int  openSocket( bool isServ  );
    int  Listen( void );
    int  Accept( void );
    int  Connect( string );
    void CloseServer( void );
    void CloseClient( void );
    //void SetSocketOptions( void ) {}
    //void SetSocket( int sock );

    virtual int doSend(const char *, long);  // sends a message on the socket
    virtual int doRecv(char *, long);  
    virtual int doBlockedRecv(char *, long, char *); // receive the next message (block until received)

    inline int getSock( void )
    {
	return xSock;
    };

	
  private:

    int      xSock;             // socket file descriptor (sockfd)
    short    xPort;    // port to listen to
    bool     isServer;
    std::string xRemoteHost;

};
#endif // SOCKET_H
